unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    d_Edit: TLabeledEdit;
    b_Edit: TLabeledEdit;
    C_Edit: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TPointSeries;
    Button1: TButton;
    Series3: TLineSeries;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Series4: TPointSeries;
    degreeEdit: TLabeledEdit;
    CheckBox2: TCheckBox;
    Series5: TLineSeries;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    function datainput: boolean;
    procedure Drawing(yyt, yyb: double; j: integer);
    procedure dataset(n: integer;var ab: array of double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  system.Math;

var
  C : double;       // Jei[
  d : double;       // XW
  b : double;       // YW
  deg : integer;    // ̎
  xs, xe: double;   // X͈̔
  yt:     double;   // y͈̔
  a1, a2 :  double; // ̌X

// Durand Kerner Aberth algorithm
function dka(a : array of double; var cr, ci: array of double; n: integer): boolean;
var
  r, r0, t : double;
  e, f1, f2, w1, w2 : double;
  p1, p2, a1, a2, norm: double;
  i, j, L: integer;
  ca : array of double;
  zc : double;
  StrText : string;
  eps     : double;
begin
  result := true;
  setlength(ca, n + 1);

  for i := 0 to n do ca[i] := a[i];
  zc := - ca[n-1] / n;
  for i := 1 to n do
    for j := n downto i do
      ca[j-1] := ca[j-1] + ca[j] * zc;
  r := 0;
  for i := 0 to n - 1 do begin
    r0 := power(n * abs(ca[i]), 1/(n-i));
    if r < r0 then r := r0;
  end;
  Form1.Memo1.Lines.Add('R = ' + floatTostr(r));

  eps := 1E-15 * r;                         // laŒ
  for i := 1 to n  do begin                 // ar̉~ɓԊuɔzu
    t := 2 * PI / n * (i - 3.0 / 4.0);
    cr[i-1] := -a[n-1] / n + r * cos(t);    // A[oX̏l
    ci[i-1] := r * sin(t);
  end;
  L := 0;
  try
    repeat
      e := 0;
      for i := 0 to n -1 do begin
        f1 := 1;                              // q@f(zi)A=f1,=f2
        f2 := 0;                              // a[n]=1
        for j := n-1 downto 0 do begin        // z[i[@@f(z)=( c ((z+a[n-1])*z+a[n-2])*z+a[n-3])* c +a[1])*z+a[0]
          w1 := f1 * cr[i] - f2 * ci[i];      // f*z=(f1+i*f2)*(x1+i*x2)=(f1*x1-f2*x2)+i*(f1*x2+f2*x1)
          w2 := f2 * cr[i] + f1 * ci[i];
          f1 := w1 + a[j];                    // f=z+a[j]
          f2 := w2;
        end;
        p1 := 1;                              // @[j=1,N,ij](zi-zj)A=p1,=p2
        p2 := 0;
        for j := 0 to  n - 1 do begin
          if j <> i then begin
            w1 := p1 * (cr[i] - cr[j]) - p2 * (ci[i] - ci[j]);    // p*(zi-zj)
            w2 := p1 * (ci[i] - ci[j]) + p2 * (cr[i] - cr[j]);
            p1 := w1;                                             // p=(zi-zj)
            p2 := w2;
          end;
        end;

        t := p1 * p1 + p2 * p2;               // q@(f1+i*f2)/(p1+i*p2)=(f1+i*f2)(p1-i*p2)/(p1*p1+p2*p2)
        if t = 0 then begin
          application.MessageBox('Oł͊܂B(DKA[`)', '', 0);
          result := false;
          exit;
        end;
        a1 := (f1 * p1 + f2 * p2) / t;
        a2 := (f2 * p1 - f1 * p2) / t;
        norm :=sqrt(a1 * a1 + a2 * a2);
        if e < norm then e := norm;           // ől

        cr[i] := cr[i] - a1;                  // kڂ̋ߎ@zi[k+1]=zi[k]-f(zi[k])/[j=1,N,ij](zi[k]-zj[k])
        ci[i] := ci[i] - a2;
      end;
      inc(L);
    until (e < eps) or (L > 400);
  except
    on E: Exception do begin
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + #13#10 + 'DKA@vZ[`';
      StrText := StrText + sLineBreak + 'I[o[t[玟ČvZĂ݂ĂB';
      Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
      result := False;
    end;
  end;
  Form1.Memo1.Lines.Add('DKA@@Loop = ' + intTostr(L))
end;

// ͏
function TForm1.datainput: boolean;
var
  ch: integer;
begin
  result := false;
  val(C_edit.Text, C, ch);
  if (ch <> 0) or (C <= 0) then begin
    application.MessageBox('Jei[ɊԈႢ܂B','',0);
    exit;
  end;
  val(d_edit.Text, d, ch);
  if ch <> 0 then begin
    application.MessageBox('ʉߓ_wWɊԈႢ܂B','',0);
    exit;
  end;
  val(b_edit.Text, b, ch);
  if (ch <> 0) then begin
    application.MessageBox('ʉߓ_xWɊԈႢ܂B','',0);
    exit;
  end;
  val(degreeedit.Text, deg, ch);
  if (ch <> 0) then begin
    application.MessageBox('̎ɊԈႢ܂B','',0);
    exit;
  end;
  if deg > 50 then begin
    application.MessageBox('̎̒l傫܂iTOjB','',0);
    exit;
  end;
  if deg < 4 then begin
    application.MessageBox('̎̒l܂iSȏjB','',0);
    exit;
  end;
  result := true;
end;

// @ڐ}
// yyt Ot  yyb Ot
// J = 2 ڐ}  J <> 2 ڐ
procedure TForm1.Drawing(yyt, yyb: double; j: integer);
const
  K = 500;
var
  xn  : double;
  x, dx : double;
  y   : double;
  i   : integer;
begin
  dx := (xe - xs) / K;
  //  ڐ}
  for i := -50 to K + 50 do begin
    xn := i * dx + xs;                // vZʒu
    x := abs(xn);
    y := C * (cosh(x / C) - 1);       // Jei[Ȑ
    if (y < yyt) and (y >= yyb) then Series1.AddXY(xn, y);
    if j = 2 then begin
      y := a1 * (xn - d) + b;                  // 
      if (y < yyt) and (y >= yyb) then Series3.AddXY(xn, y);
      y := a2 * (xn - d) + b;                  // 
      if (y < yyt) and (y >= yyb) then Series5.AddXY(xn, y);
    end;
  end;
end;

// cosh sinhlpNf[^[쐬
procedure TForm1.dataset(n: integer; var ab: array of double);
var
  i : integer;
  function factorial(n: integer): double;       // n!
  var
    j : integer;
  begin
    result := 1;
    for j := 2 to n do result := result * j;
  end;
begin
  ab[0] := -b;                         // 萔
  for i := 1 to n do begin
    if i mod 2 = 0 then ab[i] := (1 / factorial(i) - 1 / factorial(i - 1)) / power(C, i - 1)  // 
                   else ab[i] := d / factorial(i) / power(C, i);                              // 
  end;
end;

// Jei[ƒ̌_vZ̎s
procedure TForm1.Button1Click(Sender: TObject);
var
  ab : array of double;           // f[^[
  cr : array of double;           // 
  ci : array of double;           // 
	i, n, j, ch: integer;
  fd  : double;
  li   : int64;
  scou : string;
  x : array of double;            // @Xl
  ys : array of double;           // yl
  yc : array of double;           // Jei[Yl
  xxs, xxe  : double;             // Otx͈
  yyb, yyt  : double;             // Oty͈
  StrText   : string;

  // ۂ
  procedure roundfd(var d: double);
  begin
    if abs(d) < 1E5 then begin
      li := round(d * 1E8);              // _8ȉۂ
      d := li / 1E8;
    end;
  end;

begin
  Button1.Enabled := False;
  xs := -1;
  xe :=  1;
  // f[^[͏
  if not datainput then begin
    Button1.Enabled := true;
    exit;
  end;
  n := deg;
  // Ŕz̊m
  setlength(ab, n + 1);
  setlength(cr, n);
  setlength(ci, n);
  setlength(x, 3);
  setlength(ys, 2);
  setlength(yc, 2);

  // zɃf[^[Zbg   sinh cosh
  dataset(n, ab);
  j := 0;
  // z擪̒lPɐݒ
  if ab[n] = 0 then begin
    memo1.Clear;
    memo1.Lines.Add('DKA@');
    memo1.Lines.Add(' f[^[z̐擪̒lOi[jłB');
    memo1.Lines.Add(' ɂĉB');
    Button1.Enabled := True;
    exit;
  end;
  try
    for i := n - 1 downto 0 do begin
      ab[i] := ab[i] / ab[n];
    end;
  except
    on E: Exception do begin       // I[o[t[
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + #13#10 + 'z̐擪Pɂ鏈';
      Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
      j := 1;
    end;
  end;
  if j = 1 then begin              // I[o[t[L獟
    Button1.Enabled := True;
    exit;
  end;
  ab[n] := 1;

  memo1.Clear;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series5.Clear;
  application.ProcessMessages;     // Clear҂
  memo1.Lines.Add('DKA@@ = ' + intTostr(n));
  // dka@@vZ
  if not dka(ab, cr, ci, n) then begin      // G[L獟
    Button1.Enabled := true;
    exit;
  end;
  // dka@@\
  if checkbox2.Checked then
    for i := 0 to n-1 do begin
      fd := cr[i];                          // 
      roundfd(fd);                          // _8ȉۂ
      scou := 'x' + inttostr(i + 1) + '= ' + floatTostr(fd);
      ch := length(scou);
      ch := 28 - ch;
      for j := 0 to ch do scou := scou + ' ';
      fd := ci[i];                          // 
      roundfd(fd);                          // _8ȉۂ
      memo1.Lines.Add(scou + floatTostr(fd) + ' i');
    end;
  // ړ_̌o ꏊ
  ch := 0;
  for i := 0 to n - 1 do begin
    if abs(ci[i]) < 1E-8 then begin
      fd := cr[i];
      if ch <= 2 then begin
        x[ch] := fd;
      end;
      inc(ch);
    end;
  end;
  if ch = 0 then begin
    memo1.Lines.Add('');
    memo1.Lines.Add('ړ_oł܂łB');
  end;
  if ch = 1 then begin
    memo1.Lines.Add('');
    memo1.Lines.Add('ړ_𕪗ł܂łB');
    memo1.Lines.Add('ɂĉB');
  end;
  if ch > 2 then begin
    memo1.Lines.Add('');
    memo1.Lines.Add('ړ_𐳂oł܂łB');
    memo1.Lines.Add('ɂĉB');
    memo1.Lines.Add('');
  end;
  // ̎͐Βl̈ԑ傫lx[2]ֈړ
  if ch = 3 then begin
    for n := 0 to 2 do
      for i := 0 to 1 do begin
        if abs(x[i]) > abs(x[i + 1]) then begin
          fd := x[i];
          x[i] := x[i + 1];
          x[i + 1] := fd;
        end;
    end;
  end;
  if (ch = 2) or (ch = 3) then begin                          // ڐLꍇ̌ʕ\
    memo1.Lines.Add('ړ_');
    xs := x[0];
    xe := x[1];
    a1 := sinh(xs / C);                         // 1̌X
    a2 := sinh(xe / C);                         // 2̌X
    ys[0] := a1 * (xs - d) + b;
    yc[0] := C * (cosh(xs / C) -1);
    ys[1] := a2 * (xe - d) + b;
    yc[1] := C * (cosh(xe / C) -1);
    // ʕ\\
    for j := 0 to 1 do begin
      memo1.Lines.Add(' X' + inttostr(j + 1) + '=' + floatTostrF(x[j],ffGeneral, 10, 8));

      memo1.Lines.Add('@@@@ @@@@Y ' + inttostr(j + 1) + '=' + floatTostrF(ys[j], ffGeneral, 10, 8));
      memo1.Lines.Add('@@@@@@@Y ' + inttostr(j + 1) + '=' + floatTostrF(yc[j], ffGeneral, 10, 8));
      memo1.Lines.Add('@@@  ' + floatTostr(yc[j] - ys[j]));

      if j = 0 then begin
        memo1.Lines.Add('@@@a = ' + floattostr(a1));
        fd := ys[0] - a1 * xs;
      end
      else begin
        memo1.Lines.Add('@@@a = ' + floattostr(a2));
        fd := ys[1] - a2 * xe;
      end;
      memo1.Lines.Add('@@@b = ' + floatTostr(fd));
    end;
    if ch = 3 then memo1.Lines.Add(' X3' + '=' + floatTostrF(x[2],ffGeneral, 10, 8) + '  svf[^[');
    ch := 2;
  end
  else begin                                      // ڐꍇ̃Otݒ
    xs := -C;
    xe :=  C;
    if d < xs then xs := d;
    if d > xe then xe := d;
    ys[0] := 0;
    yc[0] := C * (cosh(xs / C) -1);
    ys[1] := b;
    yc[1] := C * (cosh(xe / C) -1);
  end;
  // Ot\XP[ݒ
  if xe * xs <= 0 then yyb := 0                   // x̒l-x `+x Ȃ  yl0
                  else begin
                    yyb := ys[0];                 // -x-x  +x+x Ȃ
                    fd :=  ys[1];
                    if fd < yyb then yyb := fd;   // ylI
                  end;
  if ys[0] > ys[1] then yt := ys[0]               // 傫ylI
                   else yt := ys[1];
  if b < yyb then yyb := b;
  if xe < xs then begin                           // ̒lxs
    fd := xe;
    xe := xs;
    xs := fd;
  end;
  yyt := yt;                                      // Ot㑤̒l
  xxs := xs;                                      // xXP[
  xxe := xe;
  if (xxs - xxe) < 1E-8 then begin
    xxs := xxs - 0.1;
    xxe := xxe + 0.1;
    xs := xxs;
    xe := xxe;
  end;
  if (xxe - xxs) > (yyt - yyb) then begin         // cXP[ݒ
    fd := ((xxe - xxs) - (yyt - yyb)) / 2;
    yyb := yyb - fd;
    yyt := yyt + fd;
  end
  else begin
    fd := ((yyt - yyb) - (xxe - xxs)) / 2;
    xxs := xxs - fd;
    xxe := xxe + fd;
  end;
  fd := (xxe - xxs) / 10;                         // Ot]Tݒ
  xxs := xxs - fd;
  xxe := xxe + fd;
  yyb := yyb - fd;
  yyt := yyt + fd;
  if checkbox1.Checked then begin
    Series2.AddXY(xxs, yyt);
    Series2.AddXY(xxs, yyb);
    Series2.AddXY(xxe, yyb);
    application.ProcessMessages;                  // Ot\҂ XP[ݒ
  end;
  // Ot\ Jei[Ɛڐ
  j := 0;
  try
    Drawing(yyt, yyb, Ch);
  except
    on E: Exception do begin       // I[o[t[
      StrText := E.ClassName + sLineBreak + E.Message;
      StrText := StrText + #13#10 + 'Ot}[`';
      Application.MessageBox(PChar(StrText), '', MB_ICONINFORMATION);
      j := 1;
    end;
  end;
  if j = 1 then begin              // I[o[t[L獟
    Button1.Enabled := True;
    exit;
  end;
  if ch = 2 then Series4.AddXY(x[0], ys[0]);      // ړ_
  Series4.AddXY(d, b);                            // w_
  if ch = 2 then Series4.AddXY(x[1], ys[1]);      // ړ_E
  Button1.Enabled := true;
end;

end.
